import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashSet;

import jec.EventSearchCriteria;
import jec.ExchangeConnectorFactory;
import jec.ExchangeConnectorInterface;
import jec.ExchangeConstants;
import jec.ExchangeGeneralException;
import jec.InvalidSearchCriteriaException;
import jec.OREventSearchCriteria;
import jec.dto.ExchangeContactDTO;
import jec.dto.ExchangeEmailDTO;
import jec.dto.ExchangeEventAttendeeDTO;
import jec.dto.ExchangeEventDTO;
import jec.dto.ExchangeTaskDTO;
import jec.dto.UserAvailabilityData;
import jec.utils.AppLogger;
import java.util.Calendar;


public class MeetingReqExamples {


//    static  String _exchangeHost = "192.168.0.102";
//    static  String _applicationUserAccountName = "test2";
//    static  String _applicationUserPassword = "Kikaha58";
//    static  String _prefix = "Exchange";
//    static  String _mailboxName = "test2";
//    static  boolean _useSSL = false;
//    static String _email = "test2@domain1.com";
//    static String _domain = "domain1.com";
//    static String _fbaDomain = "domain1";

    static  String _exchangeHost = "80.33.236.119";
   static  String _applicationUserAccountName = "dgi";
   static  String _applicationUserPassword = "Soluziona123";
   static  String _prefix = "Exchange";
   static  String _mailboxName = "dgi";
   static  boolean _useSSL = false;
   static String _email = "dgi@ExchangeServer.labo";
   static String _domain = "ExchangeServer.labo";
   static String _fbaDomain = "domain1";





    public static void main(String[] args) {
        try {
            BufferedReader in = new BufferedReader(new InputStreamReader(System.
                    in));
            String str = null;
            System.out.println("Welcome to JEC example!");
            System.out.println(
                    "To use the main default values just press <Enter>");
            System.out.println("");
            System.out.println("Please insert Exchange IP or host name: ");
            try {
                str = in.readLine();
            } catch (IOException ex1) {
                ex1.printStackTrace();
            }
            if ((str != null) && (!str.equals("")))
                _exchangeHost = str;
            System.out.println("Exchange Host:" + _exchangeHost);
            System.out.println("");

            System.out.println("Please insert Exchange user name: ");
            try {
                str = in.readLine();
            } catch (IOException ex1) {
                ex1.printStackTrace();
            }
            if ((str != null) && (!str.equals("")))
                _applicationUserAccountName = str;
            System.out.println("");
            System.out.println("Application User Account Name:" +
                               _applicationUserAccountName);

            System.out.print("Please insert Exchange password: ");
            try {
                str = in.readLine();
            } catch (IOException ex1) {
                ex1.printStackTrace();
            }
            if ((str != null) && (!str.equals("")))
                _applicationUserPassword = str;
            System.out.println("");
            System.out.println("Application User Password:" +
                               _applicationUserPassword);

            System.out.print(
                    "Please insert mailbox name (in most cases its the same as the user name): ");
            try {
                str = in.readLine();
            } catch (IOException ex1) {
                ex1.printStackTrace();
            }
            if ((str != null) && (!str.equals("")))
                _mailboxName = str;
            System.out.println("");
            System.out.println("Mailbox Name:" + _mailboxName);




            addEventWithAttendeesExample();

            try {
                Thread.sleep(1000);
            } catch (InterruptedException ex2) {
            }
            acceptMeetingExample();
            try {
                Thread.sleep(1000);
            } catch (InterruptedException ex2) {
            }
//
//            getEventsExample();




        } catch (ExchangeGeneralException ex) {
            ex.printStackTrace();
        }
    }



    public static void getEventsExample() throws ExchangeGeneralException {

        ExchangeConnectorFactory factory = new ExchangeConnectorFactory();
        ExchangeConnectorInterface connector = null;


        connector = factory.createExchangeConnector(_exchangeHost,
                "ema",
                "Soluziona123",
                _prefix, _useSSL, "ema", "GMT+00:00");
        connector.setCalendarFolderName("Calendario");


        Date startDate = null;
        Date endDate = null;

        try {
            // getting todays events (6:00 -> 22:00)
            /* Date today = new Date();
            Calendar calStart = Calendar.getInstance();
            Calendar calEnd = Calendar.getInstance();
            calStart.setTime(today);
            calStart.set(Calendar.HOUR_OF_DAY, 6);
            calStart.set(Calendar.MINUTE, 0);

            calEnd.setTime(today);
            calEnd.set(Calendar.HOUR_OF_DAY, 22);
            calEnd.set(Calendar.MINUTE, 0);
            startDate = calStart.getTime();
            endDate = calEnd.getTime();
        */
       SimpleDateFormat dateFormat = new SimpleDateFormat(
               "yyyy-MM-dd HH:mm:ss");
        startDate = null;
        endDate = null;

       startDate = dateFormat.parse("2007-12-12 6:00:00");
       endDate = dateFormat.parse("2007-12-12 19:00:00");




        } catch (Exception ex) {
            ex.printStackTrace();
        }
        System.out.println("getting events from startDate: " + startDate +
                           " to endDate: " + endDate);

        ArrayList events = connector.getEvents(startDate,
                                               endDate, 100);
        for (int i = 0; i < events.size(); i++) {
            System.out.println("event " + i + " getUniqueIdForUrl: " +
                               ((ExchangeEventDTO) events.get(i)).getUniqueIdForUrl());
            System.out.println("event " + i + " subject: " +
                               ((ExchangeEventDTO) events.get(i)).getSubject());
            System.out.println("event " + i + " location: " +
                               ((ExchangeEventDTO) events.get(i)).getLocation());
            System.out.println("event " + i + " busy status: " +
                               ((ExchangeEventDTO) events.get(i)).getBusyStatus());
            System.out.println("event " + i + " all day event: " +
                               ((ExchangeEventDTO) events.get(i)).
                               getIsAllDayEvent());
            System.out.println("event " + i + " StartDate: " +
                              ((ExchangeEventDTO) events.get(i)).getStartDate()
                              );

            System.out.println("event " + i + " EndDate: " +
                              ((ExchangeEventDTO) events.get(i)).getEndDate()
                              );


            System.out.println("event " + i + " Is Recurrent event: " +
                               ((ExchangeEventDTO) events.get(i)).
                               getIsRecurrent());

            System.out.println("event " + i + " description: " +
                               ((ExchangeEventDTO) events.get(i)).getDescription()
                               );

            System.out.println("event " + i + " organizer: " +
                               ((ExchangeEventDTO) events.get(i)).getOrganizer()
                               );



            ////////////////////////////// getting event attendees ///////////////////////////
            if ( ((ExchangeEventDTO) events.get(i)).getTo()!= null) {
                System.out.println("event " + i + " number of attendees: " +
                                   ((ExchangeEventDTO) events.get(i)).getTo().
                                   size());
                for (int j = 0; j < ((ExchangeEventDTO) events.get(i)).getTo().
                                   size(); j++) {
                    System.out.println("attendee " + j + ":" +
                            ((ExchangeEventAttendeeDTO)(((ExchangeEventDTO) events.get(i)).getTo().get(j))).getDisplayName() +
                             " " +
                            ((ExchangeEventAttendeeDTO)(((ExchangeEventDTO) events.get(i)).getTo().get(j))).getEmailAddr()   );

                    System.out.println("attendee " + j + " type (ATTENDEE_TYPE_REQUIRED=1, ATTENDEE_TYPE_=3)" + j + ":" +
                                       ((ExchangeEventAttendeeDTO) (((
                            ExchangeEventDTO) events.get(i)).getTo().get(j))).getType()
                                       );
                    System.out.println("attendee " + j + ":" +
                            ((ExchangeEventAttendeeDTO)(((ExchangeEventDTO) events.get(i)).getTo().get(j))).getDisplayNameAndEmailStr());

                }
            }
            ////////////////////////////////////////////////////////////////////////////////////////////////

            System.out.println("");

        }

    }








    public static void addEventWithAttendeesExample() throws ExchangeGeneralException {
        System.out.println("============= addEventWithMeetingReqsExample start. ==========");
        ExchangeConnectorFactory factory = new ExchangeConnectorFactory();
        ExchangeConnectorInterface connector = null;
        connector = factory.createExchangeConnector(_exchangeHost,
                _applicationUserAccountName,
                _applicationUserPassword,
                _prefix, _useSSL, _mailboxName, "GMT+01:00" );

        // in case you dont want to send meeting requests, but you want to add the attendees to
        // the meeting, uncomment this line.
        // in case send meeting is true, you'll need to install the optional package
        // download from: http://jec-users.googlegroups.com/web/optional1.0.zip?gda=eVYGfkAAAAA_NSrvJ0P5DI-9bvJkcZCa5Ggbk6bEOimn1NyX_8i6xWG1qiJ7UbTIup-M2XPURDTahN4g7xphsKA-V8V9oYIn&hl=en
        connector.setSendMeetingReqs(true);

        // this is needed to send a correct meeting request, for the correct format of this String look at the connector api docs
        connector.setFullTimezonStr4MeetingReq("(GMT+02.00) Israel/Jerusalem Standard Time");

        connector.setCalendarFolderName("Calendario");

        SimpleDateFormat dateFormat = new SimpleDateFormat(
                "yyyy-MM-dd HH:mm:ss");
        Date startDate = null;
        Date endDate = null;
        try {
            startDate = dateFormat.parse("2007-12-12 18:00:00");
            endDate = dateFormat.parse("2007-12-12 19:00:00");
        } catch (ParseException ex) {
            ex.printStackTrace();
        }

        ExchangeEventDTO event = new ExchangeEventDTO();
        ExchangeEventAttendeeDTO from = new ExchangeEventAttendeeDTO();
        from.setEmailAddr(_email);
        event.setFrom(from);

//        ExchangeEventAttendeeDTO to1 = new ExchangeEventAttendeeDTO();
//        to1.setEmailAddr(_email);
//        event.addTo(to1);

        ExchangeEventAttendeeDTO to2 = new ExchangeEventAttendeeDTO();
        to2.setType(ExchangeEventAttendeeDTO.ATTENDEE_TYPE_REQUIRED);
        to2.setEmailAddr("ema@ExchangeServer.labo");
        event.addTo(to2);

//        ExchangeEventAttendeeDTO to3 = new ExchangeEventAttendeeDTO();
//        to3.setType(ExchangeEventAttendeeDTO.ATTENDEE_TYPE_OPTIONAL);
//        to3.setEmailAddr("test3@domain1.com");
//        event.addTo(to3);



        event.setSubject("eli test event " + System.currentTimeMillis());
        event.setLocation("test location");
        event.setDescription("my test event");
        event.setStartDate(startDate);
        event.setEndDate(endDate);
        event.setImportance(2);
        event.setBusyStatus(ExchangeEventDTO._calendarBusyStatus_BUSY);
        //event.setIsAllDayEvent(true);

        try {
            connector.addEvent(event);
        } catch (java.lang.NoClassDefFoundError ex1) {
            ex1.printStackTrace();
            System.out.println("you probelby missing the optional package,");
            System.out.println("download from: http://jec-users.googlegroups.com/web/optional1.0.zip?gda=eVYGfkAAAAA_NSrvJ0P5DI-9bvJkcZCa5Ggbk6bEOimn1NyX_8i6xWG1qiJ7UbTIup-M2XPURDTahN4g7xphsKA-V8V9oYIn&hl=en");
        }
        System.out.println("look at: " + startDate +
                           " events to see that the event was added.");


    }

    public static void acceptMeetingExample() throws ExchangeGeneralException {
        System.out.println("============== acceptMeetingExample() start ===========");
        ExchangeConnectorFactory factory = new ExchangeConnectorFactory();
        ExchangeConnectorInterface connector = null;
//        String applicationUserAccountName = "test1";
//        String mailboxName = "test1";

        String applicationUserAccountName = "ema";
        String mailboxName = "ema";
        String applicationUserPassword = "Soluziona123";

        connector = factory.createExchangeConnector(_exchangeHost,
                applicationUserAccountName,
                applicationUserPassword,
                _prefix, _useSSL, mailboxName);

        connector.setCalendarFolderName("Calendario");
        connector.setEmailFolderName("Bandeja%20de%20entrada");

        SimpleDateFormat dateFormat = new SimpleDateFormat(
                "yyyy-MM-dd HH:mm:ss");
        Date sinceDate = null;
        try {
            sinceDate = dateFormat.parse("2007-10-25 06:00:00");
        } catch (ParseException ex) {
            ex.printStackTrace();
        }

        int maxEmailsReturned = 100;

        // we need to get full email Str in-order to parse the meeting request part
        connector.setGetFullEmailStr(true);

        // open the comment if you want to accept the meeting, but not to send
        // accept email.
        //connector.setSendMeetingAcceptEmail(false);

        ArrayList emailsArrayList = connector.getEmails(
                sinceDate,
                null,
                null,
                maxEmailsReturned);
       System.out.println("emailsArrayList.size() : " + emailsArrayList.size());
       for (int i = 0; i <  emailsArrayList.size(); i++) {
           ExchangeEmailDTO email = (ExchangeEmailDTO) emailsArrayList.get(i);
           System.out.println("subject: " + email.getSubject());
           if (email.isMeetingRequest()) {
               System.out.println("found meeting request email accepting ...");
               //System.out.println(email.getEmailStr());
               System.out.println("getMeetingStartTimeStr: " + email.getMeetingStartTimeStr());
               System.out.println("getMeetingOwner: " + email.getMeetingOwner());
               System.out.println("getMeetingDescription: " + email.getMeetingDescription());
               System.out.println("getMeetingReqLocation: " + email.getMeetingReqLocation());
               connector.accept(email);
           }

       }


    }









}
